#!/bin/bash
MAIL=/tmp/mail_week
DIRECTORY=/home/valentin/mail
SERVER_LOG=/var/log/nginx
DATE=$(date +%Y%m%d-%H%M%S)
HOST=($(cat /etc/sentinel/virtualhost))
for i in ${HOST[@]}
do
	directory_host=$DIRECTORY/$i/*
	echo "nombre de visite : $(wc -l $directory_host/list_* |tail -n1 | awk '{print $1}')" > ${MAIL}
	echo "nombre de visite par pays, par region et par ville : " >> ${MAIL}
	LIST=("country" "region" "city")
	for j in ${LIST[@]}
	do
		echo "----${j}------" >> ${MAIL}
		cat $directory_host/output_*.txt |grep "${j}" |sort |uniq -c >> ${MAIL}
		echo "--------------" >> ${MAIL}
	done
	ERROR=("400" "404")
	for j in ${ERROR[@]}
	do
		echo "nombre erreur ${j} par IP :" >> ${MAIL}
		cat $directory_host/${j}_* |sort |uniq -c >> ${MAIL}
		echo "----------------" >> ${MAIL}
	done
	echo "nombre de robots :" >> ${MAIL}
	cat $directory_host/robots_* |sort |uniq -c >> ${MAIL}
	echo "----------------" >> ${MAIL}

	cat ${MAIL} |mail -s "Rapport mensuel reverse proxy ${i} $DATE" valczebackup@gmail.com
	rm -rf $directory_host
done
